const Task = require('data.task')
const fs = require('fs')
const toTask = require('futurize').futurize(Task)
const exec = require('./exec')

const writeFile = toTask(fs.writeFile)
const readFile = toTask(fs.readFile)
const readDir = toTask(fs.readdir)


const copy = (from, to) =>
  exec(`cp -r ${from} ${to}`)

const rmRf = dir =>
  exec(`rm -rf ${dir}`)

module.exports = {
  writeFile, readFile, readDir, copy, rmRf
}
