var fs = require('fs')
var system = require('system');
var testDir = system.args[1]
var stylePath = system.args[2]
var files = fs.list(testDir);

var page = require('webpage').create();
page.viewportSize = {width: 600, height: 800}


// Would be very generic tool were it not for this template
// This is a hack to remove redundency in each html example.
const template = ' \
  <!DOCTYPE html> \
  <html lang="en" style="overflow-y: auto;"> \
    <head> \
    <title>Salesforce User Experience SLDS Test</title> \
    <meta charset="utf-8"> \
    <style> \
      {STYLEZ} \
    </style> \
    </head> \
    <body> \
      <div id="example">{EXAMPLE}</div> \
    </body> \
  </html> \
'

// this too (look above)
var style = fs.read(stylePath)
var bdy = template.replace('{STYLEZ}', style)

page.onConsoleMessage = function(msg) {
  var o = JSON.parse(msg)
  console.log(JSON.stringify(o))
};

for(file in files) {
  if(fs.isFile(testDir+files[file])){
  var example = fs.read(testDir+files[file]);
  var content = bdy.replace('{EXAMPLE}', example)
  page.content = content
   page.evaluate(function(name, example, html) {
    var getStyle = function(style) {
      return Object.keys(style).reduce(function(acc, k) {
        var v = style.getPropertyValue(k)
        if(v != null) acc[k] = v
        return acc
      }, {})
    }
    var kids = [].slice.call(document.body.getElementsByTagName("*"))
    var style = []
    for(node in kids) {
      style.push(getStyle(window.getComputedStyle(kids[node])))
    }
    console.log(JSON.stringify({name: name, html: example, style: style}))
   }, files[file], example, content)
  }
}

phantom.exit()
